#version 430 core

in vertexData{
	flat vec3 position_world;
	vec2 uv;
} vert;



flat in float TTL0;
out vec4 FragColor;
layout (location = 0) out vec4 color;
layout (location = 1) out vec4 normalsTexture;


uniform bool depthEnabled = true;

// Cell shading
uniform bool cellShadeEnabled = true;
uniform sampler1D cellShadeTexture;
uniform vec3 camera_world;
uniform vec3 materialCoefficients = vec3(0.1f, 0.7f, 0.1f); // x = ambient, y = diffuse, z = specular 
uniform float specularAlpha =  2.0f;

uniform vec3 relativeLightPos = vec3(1.f);

uniform struct DirectionalLight {
	vec3 color;
	vec3 direction;
} dirL;

uniform struct PointLight {
	vec3 color;
	vec3 position;
	vec3 attenuation;
} pointL;

// float cellShadeLightIntensity(vec3 normallizedNormal, vec3 lightDir, vec3 viewDir, float diffuseF, float specularF, float alpha, bool attenuate, vec3 attenuation, vec3 lightCol);



void main() {
	
	vec2 uv = vert.uv;


	uv -=vec2(0.5, 0.5);

	vec3 tempColor = vec3(1.);

	
	float alpha = 1;


	float dist = sqrt(dot(uv, uv));
	
	if( dist > 0.45)
	{
		if(depthEnabled)
		{
			discard; // Fragment wont be rendered because of this it will also not be written to depth buffer
		}
		else
		{
			{//			if(dist <= 0.5)
//			{
//				alpha = 0.5;
//			}
//			else
//			{
//				discard; // Fragment wont be rendered because of this it will also not be written to depth buffer
//			}
			}
			// When not writing to depht buffer:

			discard;
		}
	}
	if(cellShadeEnabled)
	{
		color = vec4(tempColor * materialCoefficients.x, alpha);
		float intensity = 0;
//		intensity += cellShadeLightIntensity(n, -dirL.direction, v, materialCoefficients.y, materialCoefficients.z, specularAlpha, false, vec3(0), dirL.color);
//		intensity += cellShadeLightIntensity(n, relativeLightPos - vert.position_world, v, materialCoefficients.y, materialCoefficients.z, specularAlpha, true, pointL.attenuation, pointL.color);

		vec3 lightDirection = relativeLightPos - vert.position_world;
		float lightDistance = length(lightDirection) / 2;		
		intensity = 1 /lightDistance;

		if(intensity < 1)
		{
			intensity = texture(cellShadeTexture, intensity).r;
		}
		else
		{
			intensity = 1.;
		}

		color.rgb += tempColor * intensity;

		normalsTexture = vec4(1);	
	}
	else
	{
		color = vec4(tempColor, alpha);
		
		normalsTexture = vec4(1);
	}


}



//float cellShadeLightIntensity(vec3 normallizedNormal, vec3 lightDir, vec3 viewDir, float diffuseF, float specularF, float alpha, bool attenuate, vec3 attenuation, vec3 lightCol) {
//	float d = length(lightDir);
//	lightDir = normalize(lightDir);
//	float lightColIntensity = length(lightCol);
//	float att = 1.0;	
//	if(attenuate) att = 1.0f / (attenuation.x + d * attenuation.y + d * d * attenuation.z);
//	vec3 lightRef = reflect(-lightDir, normallizedNormal);
//	return (diffuseF * max(0, dot(normallizedNormal, lightDir)) *att + specularF * pow(max(0, dot(lightRef, viewDir)), alpha) * att) * lightColIntensity; 
//}